#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#include "brickget.c"
#include "keys.h"

char far *scr;

#define MAXX          320
#define MAXY          200
#define SCREENADDR    0xA000

#define BRICK_HEIGHT  5
#define BRICK_WIDTH   10

int PAD_LENGTH=20;  // Lnge des PAD's
int warte=30;  // Verzgerungszeit in msec
int position=0;  // Position des PAD's
unsigned int score=0;  // Aktuelle Punkteanzahl

char BRICK[]=
{
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
//  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
//  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
//  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
//  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
//  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

  0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0
};

char *level[]=
{
     "LEVEL1.DAT",
     "LEVEL2.DAT",
     "LEVEL3.DAT",
     "LEVEL4.DAT",
     "LEVEL5.DAT",
     "LEVEL6.DAT",
     "LEVEL7.DAT",
     "LEVEL8.DAT",
     "LEVEL9.DAT",
     0
};
int levelzaehler=0,
    MAX_LEVEL=9;

struct
{
  char name[12];
  unsigned int punkte;
} highscore[5];


void setpoint(int x, int y, int col)
{
     scr=(char far *)MK_FP(SCREENADDR, y*MAXX+x);
     *scr=col;
}

int  getpoint(int x, int y)
{
     scr=(char far *)MK_FP(SCREENADDR, y*MAXX+x);
     return *scr;
}

int  get_x_sect(int x)
{
     int i,r;
     r=x%BRICK_WIDTH;
     i=(x-r)/BRICK_WIDTH;
     return i;
}

int  get_y_sect(int y)
{
     int i,r;
     r=y%BRICK_HEIGHT;
     i=(y-r)/BRICK_HEIGHT;
     return i;
}

void draw_brick(int x, int y, int c)
{
     int i,j;
     int fc,bc;

     switch(c)
     {
        case   2: fc=LIGHTBLUE;
                  bc=BLUE;
                  break;
        case   3: fc=LIGHTGREEN;
                  bc=GREEN;
                  break;
        case   4: fc=LIGHTRED;
                  bc=RED;
                  break;
        case   5: fc=LIGHTMAGENTA;
                  bc=MAGENTA;
                  break;
        case   6: fc=LIGHTCYAN;
                  bc=CYAN;
                  break;
        case 'X': fc=YELLOW;
                  bc=8;
                  break;
        default:  fc=15;
                  bc=7;
                  break;
     }

     x=BRICK_WIDTH*x;
     y=BRICK_HEIGHT*y;
     for(j=y; j<y+BRICK_HEIGHT; j++)
       for(i=x; i<x+BRICK_WIDTH; i++)
         setpoint(i,j,bc);
     for(j=y; j<y+BRICK_HEIGHT; j++)
     {
       setpoint(x,j,fc);
       setpoint(x+BRICK_WIDTH-1,j,fc);
     }
     for(i=x; i<x+BRICK_WIDTH; i++)
     {
       setpoint(i,y,fc);
       setpoint(i,y+BRICK_HEIGHT-1,fc);
     }
}

void clear_brick(int x, int y)
{
     int i,j;

     x=BRICK_WIDTH*x;
     y=BRICK_HEIGHT*y;
     for(j=y; j<y+BRICK_HEIGHT; j++)
       for(i=x; i<x+BRICK_WIDTH; i++)
         setpoint(i,j,0);
}

int  get_brick(int x, int y, char brick_array[], int h)
{
     x=get_x_sect(x);
     y=get_y_sect(y);
     if(y>=h)
       return 0;
     return brick_array[y*32+x];
}

void set_brick(int x, int y, char brick_array[], int h)
{
     x=get_x_sect(x);
     y=get_y_sect(y);
     if(y>=h)
       return;
     brick_array[y*32+x]=1;
}

void del_brick(int x, int y, char brick_array[], int h)
{
     x=get_x_sect(x);
     y=get_y_sect(y);
     if(y>=h)
       return;
     if(brick_array[y*32+x]!='X')
       brick_array[y*32+x]=0;
}

void update_brick(char brick_array[], int h)
{
     int i,j,c;
     int w=MAXX/BRICK_WIDTH;

     for(j=0; j<h; j++)
       for(i=0; i<w; i++)
           if((c=brick_array[j*w+i])!=0)
             draw_brick(i,j,c);
           else
             clear_brick(i,j);
}

int  check_for_brick(char brick_array[], int h)
{
     int i;
     for(i=0; i<h*32; i++)
     {
       if(brick_array[i]!='X')
         if(brick_array[i])
           return 1;
     }
     return 0;
}

void draw_pad(int x, int y)
{
     int i;
     for(i=x; i<x+PAD_LENGTH; i++)
     {
       setpoint(i,y,15);
       setpoint(i,y+1,15);
       setpoint(i,y+2,15);
       setpoint(i,y+3,15);
       setpoint(i,y+4,15);
     }
}

void del_pad(int x, int y)
{
     int i;
     for(i=x; i<x+PAD_LENGTH; i++)
     {
       setpoint(i,y,0);
       setpoint(i,y+1,0);
       setpoint(i,y+2,0);
       setpoint(i,y+3,0);
       setpoint(i,y+4,0);
     }
}

void draw_ball(int x, int y)
{
     setpoint(x+2, y  , 15);
     setpoint(x+1, y  , 15);
     setpoint(x  , y  , 15);
     setpoint(x-1, y  , 15);
     setpoint(x-2, y  , 15);
     setpoint(x  , y+2, 15);
     setpoint(x  , y+1, 15);
     setpoint(x  , y  , 15);
     setpoint(x  , y-1, 15);
     setpoint(x  , y-2, 15);
     setpoint(x-1, y+1, 15);
     setpoint(x+1, y+1, 15);
     setpoint(x-1, y-1, 15);
     setpoint(x+1, y-1, 15);
}

void del_ball(int x, int y)
{
     setpoint(x+2, y  ,  0);
     setpoint(x+1, y  ,  0);
     setpoint(x  , y  ,  0);
     setpoint(x-1, y  ,  0);
     setpoint(x-2, y  ,  0);
     setpoint(x  , y+2,  0);
     setpoint(x  , y+1,  0);
     setpoint(x  , y  ,  0);
     setpoint(x  , y-1,  0);
     setpoint(x  , y-2,  0);
     setpoint(x-1, y+1,  0);
     setpoint(x+1, y+1,  0);
     setpoint(x-1, y-1,  0);
     setpoint(x+1, y-1,  0);
}

int  read_highscore(void)
{
     FILE *Fptr;
     int i,j;

     for(i=0; i<5; i++)
     {
       highscore[i].punkte=0;
       for(j=0; j<12; j++)
         highscore[i].name[j]=0;
     }
     Fptr=fopen("highscor.dat", "rb");
     if(Fptr==0)
       return 0;
     for(i=0; i<5; i++)
     {
       for(j=0; j<12; j++)
         highscore[i].name[j]=fgetc(Fptr);
       highscore[i].punkte=getw(Fptr);
     }
     return 1;
}

int  write_highscore(void)
{
     FILE *Fptr;
     int i,j;

     Fptr=fopen("highscor.dat", "wb");
     if(Fptr==0)
       return 0;
     for(i=0; i<5; i++)
     {
       for(j=0; j<12; j++)
         fputc(highscore[i].name[j], Fptr);
       putw(highscore[i].punkte, Fptr);
     }
     return 1;
}

int  is_highscore(int score)
{
     int i,j;

     for(i=0; i<5; i++)
     {
       if(score>=highscore[i].punkte)
       {
         printf("Sie haben die %d. hchste Punktezahl.\n", i+1);
         printf("Bitte geben Sie ihren Namen ein (max. 11 Zeichen): ");
         for(j=4; j>i; j--)
         {
           strcpy(highscore[j].name, highscore[j-1].name);
           highscore[j].punkte=highscore[j-1].punkte;
         }
         jgets(highscore[i].name, 11, NULL);
         printf("\n");
         highscore[i].punkte=score;
         return 1;
       }
     }
     return 0;
}

int  load_level(char brick_array[], int h, char *name)
{
     FILE *Fptr;
     int c,i,j;

     Fptr=fopen(name, "rb");
     if(Fptr==0)
       return 1;
     for(i=0; i<32*h; i++)
     {
        c=fgetc(Fptr);
        if(feof(Fptr))
        {
          fclose(Fptr);
          return 2;
        }
        if(isdigit(c))
        {
          brick_array[i]=c-'0';
          printf("%d", brick_array[i]);
          if((i+1)%32==0)
            printf("\n");
        }
        else
        if(c=='X')
        {
          brick_array[i]='X';
          printf("X");
          if((i+1)%32==0)
            printf("\n");
        }
        else
          i--;
     }
     fscanf(Fptr, "Pad=%d", &PAD_LENGTH);
     fscanf(Fptr, "Geschw=%d", &warte);
     fclose(Fptr);
     return 0;
}

int  eingabe(char text[])
{
     int i;
     char lname[128];

     for(i=0; i<128; i++)
       lname[i]=0;

     textcolor(7);
     textbackground(0);
     jgets(text, 128, NULL);
     printf("\n");
     sscanf(strupr(text), "LADE %s", lname);
     if(lname[0]!=0)
     {
       printf("Neues Level %s\n", lname);
       i=load_level(BRICK, 8, lname);
       if(i==1)
       {
         printf("Fehler: Kann %s nicht ffnen.\n", lname);
         return 0;
       }
       if(i==2)
       {
         printf("Fehler: Datei hrt unvorhergesehen auf.\n");
         return 0;
       }
       return 0;
     }
     if(strcmpi(text, "Yeah")==0)
     {
       position=0;
       PAD_LENGTH=MAXX-1;
     }
     else
     if(strcmpi(text, "normal")==0)
     {
       warte=30;
       PAD_LENGTH=20;
     }
     else
     if(strcmpi(text, "liste")==0)
     {
       printf("Ihre Punkte bis jetzt: %u\n\n", score);
       printf("HIGHSCORE LISTE:\n");
       for(i=0; i<5; i++)
         printf("   %d. %13s......%u Punkte\n", i+1,
                highscore[i].name, highscore[i].punkte);
     }
     else
     if(strcmpi(text, "neu")==0)
     {
       is_highscore(score);
       randomize();
       for(i=0; i<32*8; i++)
         if(random(7)==3)
           BRICK[i]=random(6)+1;
         else
           BRICK[i]=0;
       score=0;
       printf("Zufallslevel erstellt.\n");
     }
     else
     if(strcmpi(text, "debug")==0)
     {
       printf("  warte=%d\n", warte);
       printf("  PAD_LENGTH=%d\n", PAD_LENGTH);
     }
     else
     if(strcmpi(text, "highspeed")==0)
       warte=1;
     else
     if((strcmpi(text, "hilfe")==0)||(strcmpi(text, "?")==0))
     {
       printf("Kommandos:\n");
       printf("EXIT oder Esc (Taste links neben F1) -> Zurck\n");
       printf("LADE Name.Ext -> Laden einer Leveldatei\n"
              "NORMAL -> Variablenwerte auf Standardwerte zurckstellen\n"
              "LISTE -> Anzeigen der Highscoreliste\n",
              "NEU -> Erstellen eines Zufallslevels\n\n");
     }
     else
     if((strcmpi(text, "exit")==0)||(text[0]==27))
       return 1;

     return 0;
}

int  halte(int hsec)
{
     int i;

     for(i=0; i<hsec; i++)
     {
         if(kbhit())
         {
           i=getch();
           break;
         }
         delay(10);
     }
     return i;
}

int  main()
{
     int c,i,t1,t2;
     char cheat[512];
     int ballx=6, bally=MAXY-10-3;
     int ballux=2, balluy=-2;

     read_highscore();

     asm mov ax,0x13;
     asm int 0x10;

     update_brick(BRICK, 8);
     draw_pad(position, MAXY-10);
     while(c!=27)
     {
           if(kbhit())
           {
             if((c=getch())==0)
               c=256*getch();
             del_pad(position, MAXY-10);
             switch(c)
             {
               case Left:
                      if(position>=10)
                        position-=10;
                      break;
               case Right:
                      if(position+10+PAD_LENGTH<MAXX)
                        position+=10;
                      else
                        position=MAXX-PAD_LENGTH;
                      break;
               case 't':
                      asm mov ax,3;
                      asm int 0x10;
                      printf("Level Nr. %d.\n", levelzaehler+1);
                      printf("Im Moment %u Punkte.\n\n", score);
                      while(!eingabe(cheat));
                      asm mov ax,0x13;
                      asm int 0x10;
                      update_brick(BRICK, 8);
                      draw_pad(position, MAXY-10);
                      break;
             }
             draw_pad(position, MAXY-10);
           }
           del_ball(ballx, bally);
           ballx+=ballux;
           bally+=balluy;
           if(ballx>=MAXX-3)
           {
             ballx=MAXX-3;
             ballux=-2;
           }
           if(ballx<3)
           {
             ballx=3;
             ballux=2;
           }
           if(bally>=MAXY-5)
           {
             ballx=3+random(MAXX-3-3);
             bally=MAXY-10-3;
             balluy=-2;
             if(random(2)==0)
               ballux=2;
             else
               ballux=-2;
             if(score<200)
               score=0;
             else
               score-=200;
           }
           if(bally<3)
           {
             bally=3;
             balluy=2;
           }
           if((bally>=MAXY-10-3)&&(ballx>=position)&&
              (ballx<=position+PAD_LENGTH))
           {
             balluy=-2;
           }
           draw_ball(ballx, bally);

           if(get_brick(ballx, bally, BRICK, 8))
           {
              del_ball(ballx, bally);
              del_brick(ballx, bally, BRICK, 8);
              if(get_brick(ballx, bally, BRICK, 8)!='X')
                score+=25;
              balluy=balluy*(-1);
              bally+=balluy;
              draw_ball(ballx, bally);
              update_brick(BRICK, 8);
           }
           if(!check_for_brick(BRICK, 8))
           {
              asm mov ax,3;
              asm int 0x10;
              if(levelzaehler<MAX_LEVEL)
              {
                printf("Level Nr. %d: %s\n",
                       levelzaehler+1, level[levelzaehler]);
                t1=load_level(BRICK, 8, level[levelzaehler]);
                if(t1==1)
                  printf("Fehler: Kann %s nicht ffnen.\n",
                         level[levelzaehler]);
                if(t1==2)
                  printf("Fehler: Datei hrt unvorhergesehen auf.\n");
                levelzaehler++;
              }
              else
                t1=0xFF;
              printf("\n\n");
              printf("Ihre Punkte: %d\n\n", score);
              printf("HIGHSCORE LISTE:\n");
              for(i=0; i<5; i++)
                printf("   %d. %13s......%.4u Punkte\n", i+1,
                       highscore[i].name, highscore[i].punkte);
              printf("\n\n");
//              is_highscore(score);
              printf("Bitte ein Taste drcken.\n");
//              write_highscore();
              halte(1000);
              if(t1!=0)
              {
                randomize();
                for(i=0; i<32*8; i++)
                  if(random(7)== 3)
                    BRICK[i]=random(6)+1;
              }
              asm mov ax,0x13;
              asm int 0x10;
              draw_pad(position, MAXY-10);
              update_brick(BRICK, 8);
           }
           delay(warte);
     }

     asm mov ax,0x03;
     asm int 0x10;

     printf("HIGHSCORE LISTE:\n");
     for(i=0; i<5; i++)
       printf("   %d. %13s......%.4u Punkte\n", i+1,
              highscore[i].name, highscore[i].punkte);
     printf("\n");
     printf("Ihre Punkte: %u\n\n\n", score);
     is_highscore(score);
     write_highscore();

     return 0;
}

